<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="设备信息id" prop="device_id">
                    <el-input v-model="formData.device_id" clearable placeholder="请输入设备信息id" />
                </el-form-item>
                <el-form-item label="设备名称" prop="name">
                    <el-input v-model="formData.name" clearable placeholder="请输入设备名称" />
                </el-form-item>
                <el-form-item label="是否显示 0-是 1-否" prop="is_show">
                    <el-input v-model="formData.is_show" clearable placeholder="请输入是否显示 0-是 1-否" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="supervisionMonitoringEquipmentDetailEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiSupervisionMonitoringEquipmentDetailAdd, apiSupervisionMonitoringEquipmentDetailEdit, apiSupervisionMonitoringEquipmentDetailDetail } from '@/api/supervision_monitoring_equipment_detail'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑工程监理--监控设备明细' : '新增工程监理--监控设备明细'
})

// 表单数据
const formData = reactive({
    id: '',
    device_id: '',
    name: '',
    is_show: '',
})


// 表单验证
const formRules = reactive<any>({
    device_id: [{
        required: true,
        message: '请输入设备信息id',
        trigger: ['blur']
    }],
    name: [{
        required: true,
        message: '请输入设备名称',
        trigger: ['blur']
    }],
    is_show: [{
        required: true,
        message: '请输入是否显示 0-是 1-否',
        trigger: ['blur']
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiSupervisionMonitoringEquipmentDetailDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiSupervisionMonitoringEquipmentDetailEdit(data) 
        : await apiSupervisionMonitoringEquipmentDetailAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
